<?php
namespace FiloBlu\Flow\Block\Adminhtml\Channel\Edit\Tabw;


class Grid extends \Magento\Backend\Block\Widget\Grid\Extended
{
    /**
     * @var \Magento\Framework\Module\Manager
     */
    protected $moduleManager;

    /**
     * @var \Magento\Eav\Model\ResourceModel\Entity\Attribute\Set\CollectionFactory]
     */
    protected $_setsFactory;

    /**
     * @var \Magento\Catalog\Model\ProductFactory
     */
    protected $_productFactory;

    /**
     * @var \Magento\Catalog\Model\Product\Type
     */
    protected $_type;

    /**
     * @var \Magento\Catalog\Model\Product\Attribute\Source\Status
     */
    protected $_status;
	protected $_collectionFactory;

    /**
     * @var \Magento\Catalog\Model\Product\Visibility
     */
    protected $_visibility;

    /**
     * @var \Magento\Store\Model\WebsiteFactory
     */
    protected $_websiteFactory;

    protected $_request;

    /**
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Backend\Helper\Data $backendHelper
     * @param \Magento\Store\Model\WebsiteFactory $websiteFactory
     * @param \Magento\Eav\Model\ResourceModel\Entity\Attribute\Set\CollectionFactory $setsFactory
     * @param \Magento\Catalog\Model\ProductFactory $productFactory
     * @param \Magento\Catalog\Model\Product\Type $type
     * @param \Magento\Catalog\Model\Product\Attribute\Source\Status $status
     * @param \Magento\Catalog\Model\Product\Visibility $visibility
     * @param \Magento\Framework\Module\Manager $moduleManager
     * @param array $data
     *
     * @SuppressWarnings(PHPMD.ExcessiveParameterList)
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Backend\Helper\Data $backendHelper,
        \Magento\Store\Model\WebsiteFactory $websiteFactory,
		\FiloBlu\Flow\Model\ResourceModel\Channel\Collection $collectionFactory,
        \Magento\Framework\Module\Manager $moduleManager,
        array $data = []
    ) {

        $this->_request = $context->getRequest();
        $flow = $this->_request->getParam('flow', 0);
        $collectionFactory = \Magento\Framework\App\ObjectManager::getInstance()->create('\FiloBlu\Flow\Model\ResourceModel' . "\\" . $flow . "\\Collection");

		$this->_collectionFactory = $collectionFactory;
        $this->_websiteFactory = $websiteFactory;
        $this->moduleManager = $moduleManager;
        parent::__construct($context, $backendHelper, $data);
    }

    protected function getTableData() {

        $connection = $this->_collectionFactory->getResource()->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        $maintable = $this->_collectionFactory->getResource()->getMainTable();
        $this->_columnsFactory = $connection->describeTable($maintable);
        return $this->_columnsFactory;

    }

    /**
     * @return void
     */
    protected function _construct()
    {
        parent::_construct();
		
        $this->setId('flowGrid');
        $this->setDefaultSort('id');
        $this->setDefaultDir('DESC');
        $this->setSaveParametersInSession(true);
        $this->setUseAjax(true);

    }

    /**
     * @return Store
     */
    protected function _getStore()
    {
        $storeId = (int)$this->getRequest()->getParam('store', 0);
        return $this->_storeManager->getStore($storeId);
    }

    /**
     * @return Store
     */
    protected function _getId()
    {
        $Id = (int)$this->getRequest()->getParam('id', 0);
        return $Id;
    }

    /**
     * @return $this
     */
    protected function _prepareCollection()
    {
		try{
			
			$collection =$this->_collectionFactory->load();
			$this->setCollection($collection);

			parent::_prepareCollection();
		  
			return $this;
		}
		catch(\Exception $e)
		{
			echo $e->getMessage();die;
		}
    }


    /**
     * @return $this
     * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
     */
    protected function _prepareColumns()
    {

        $this->addColumn(
            'meta_id',
            [
                'header' => __('ID'),
                'type' => 'number',
                'index' => 'id',
                'header_css_class' => 'col-id',
                'column_css_class' => 'col-id'
            ]
        );

        $this->addColumn(
            'meta_processed',
            [
                'header' => __('Processed'),
                'type' => 'number',
                'index' => 'meta_processed',
            ]
        );

        $columns = $this->getTableData();

        foreach ($columns as $column) {

            if ($column['COLUMN_NAME'] == 'meta_id' || $column['COLUMN_NAME'] == 'meta_processed')
                continue;

            $this->addColumn(
                $column['COLUMN_NAME'],
                [
                    'header' => __( $column['COLUMN_NAME']),
                    'type' =>  $column['DATA_TYPE'],
                    'index' =>  $column['COLUMN_NAME'],

                ]
            );



        }

        $block = $this->getLayout()->getBlock('grid.bottom.links');
        if ($block) {
            $this->setChild('grid.bottom.links', $block);
        }

        return parent::_prepareColumns();
    }

//     /**
//     * @return $this
//     */
//    protected function _prepareMassaction()
//    {
//        $this->setMassactionIdField('id');
//        $this->getMassactionBlock()->setFormFieldName('id');
//
//        $this->getMassactionBlock()->addItem(
//            'delete',
//            array(
//                'label' => __('Delete'),
//                'url' => $this->getUrl('flow/*/massDelete', array('_current'=>true)),
//                'confirm' => __('Are you sure?')
//            )
//        );
//        $this->getMassactionBlock()->addItem(
//            'meta_zero',
//            array(
//                'label' => __('Set Meta Processed = 0'),
//                'url' => $this->getUrl('flow/*/massMeta',array('status'=>0,'flow'=>urlencode($this->getRequest()->getParam('flow', 0)))),
//                'confirm' => __('Are you sure?')
//            )
//        );
//        $this->getMassactionBlock()->addItem(
//            'meta_one',
//            array(
//                'label' => __('Set Meta Processed = 1'),
//                'url' => $this->getUrl('flow/*/massMeta',array('status'=>1,'flow'=>urlencode($this->getRequest()->getParam('flow', 0)))),
//                'confirm' => __('Are you sure?')
//            )
//        );
//        return $this;
//    }

    /**
     * @return string
     */
    public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true,'id'=> (int)$this->getRequest()->getParam('id', 0),'flow'=> urlencode($this->getRequest()->getParam('flow', 0))));
    }

//    /**
//     * @param \Magento\Catalog\Model\Product|\Magento\Framework\Object $row
//     * @return string
//     */
//    public function getRowUrl($row)
//    {
//        return $this->getUrl(
//            'flow/*/edit',
//            ['store' => $this->getRequest()->getParam('store'), 'id' => $row->getId()]
//        );
//    }
}
